blob: ba90e8b6a495dbf0aed2302fb904293e6bede03a [file] [log] [blame]
garciadeblas93c61312016-09-28 15:12:48 +02001#!/bin/bash
garciadeblas38d91ee2019-11-07 16:31:23 +01002#
3# Licensed under the Apache License, Version 2.0 (the "License");
4# you may not use this file except in compliance with the License.
5# You may obtain a copy of the License at
6#
7# http://www.apache.org/licenses/LICENSE-2.0
8#
9# Unless required by applicable law or agreed to in writing, software
10# distributed under the License is distributed on an "AS IS" BASIS,
11# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12# See the License for the specific language governing permissions and
13# limitations under the License.
14#
garciadeblasd8bc5c32018-05-09 17:37:56 +020015REPOSITORY_BASE=https://osm-download.etsi.org/repository/osm/debian
garciadeblas7cebea82020-07-03 15:33:36 +000016RELEASE=ReleaseEIGHT
garciadeblas7bcadc52020-02-02 22:40:15 +010017REPOSITORY=stable
garciadeblas7cebea82020-07-03 15:33:36 +000018DOCKER_TAG=8
garciadeblas93c61312016-09-28 15:12:48 +020019
garciadeblas38d91ee2019-11-07 16:31:23 +010020function usage(){
21 echo -e "usage: $0 [OPTIONS]"
22 echo -e "Install OSM from binaries or source code (by default, from binaries)"
23 echo -e " OPTIONS"
24 echo -e " -r <repo>: use specified repository name for osm packages"
25 echo -e " -R <release>: use specified release for osm binaries (deb packages, lxd images, ...)"
26 echo -e " -u <repo base>: use specified repository url for osm packages"
27 echo -e " -k <repo key>: use specified repository public key url"
28 echo -e " -b <refspec>: install OSM from source code using a specific branch (master, v2.0, ...) or tag"
29 echo -e " -b master (main dev branch)"
30 echo -e " -b v2.0 (v2.0 branch)"
31 echo -e " -b tags/v1.1.0 (a specific tag)"
32 echo -e " ..."
garciadeblas9dee2a62020-11-14 23:08:37 +000033 echo -e " -c <orchestrator> deploy osm services using container <orchestrator>. Valid values are <k8s> or <swarm>. If -c is not used then osm will be deployed using default orchestrator. When used with --uninstall, osm services deployed by the orchestrator will be uninstalled"
vijaynag4b57d462020-06-08 14:23:10 +000034 echo -e " -n <ui> install OSM with Next Gen UI. Valid values are <lwui> or <ngui>. If -n is not specified osm will be installed with light-ui. When used with uninstall, osm along with the UI specified will be uninstalled"
garciadeblas9dee2a62020-11-14 23:08:37 +000035 echo -e " -s <stack name> or <namespace> user defined stack name when installed using swarm or namespace when installed using k8s, default is osm"
garciadeblas38d91ee2019-11-07 16:31:23 +010036 echo -e " -H <VCA host> use specific juju host controller IP"
37 echo -e " -S <VCA secret> use VCA/juju secret key"
38 echo -e " -P <VCA pubkey> use VCA/juju public key file"
39 echo -e " -C <VCA cacert> use VCA/juju CA certificate file"
40 echo -e " -A <VCA apiproxy> use VCA/juju API proxy"
41 echo -e " --vimemu: additionally deploy the VIM emulator as a docker container"
42 echo -e " --elk_stack: additionally deploy an ELK docker stack for event logging"
magnussonl1bbe9452020-02-25 13:43:17 +010043 echo -e " --pla: install the PLA module for placement support"
garciadeblas9dee2a62020-11-14 23:08:37 +000044 echo -e " -m <MODULE>: install OSM but only rebuild the specified docker images (LW-UI, NBI, LCM, RO, MON, POL, KAFKA, MONGO, PROMETHEUS, PROMETHEUS-CADVISOR, KEYSTONE-DB, PLA, NONE)"
45 echo -e " -o <ADDON>: ONLY (un)installs one of the addons (vimemu, elk_stack, k8s_monitor)"
46 echo -e " -O <openrc file/cloud name>: Install OSM to an OpenStack infrastructure. <openrc file/cloud name> is required. If a <cloud name> is used, the clouds.yaml file should be under ~/.config/openstack/ or /etc/openstack/"
47 echo -e " -N <openstack public network name/ID>: Public network name required to setup OSM to OpenStack"
garciadeblas38d91ee2019-11-07 16:31:23 +010048 echo -e " -D <devops path> use local devops installation path"
49 echo -e " -w <work dir> Location to store runtime installation"
50 echo -e " -t <docker tag> specify osm docker tag (default is latest)"
David Garcia79f4f532020-04-07 12:59:34 +020051 echo -e " -l: LXD cloud yaml file"
52 echo -e " -L: LXD credentials yaml file"
David Garcia404ae122020-04-28 11:47:55 +020053 echo -e " -K: Specifies the name of the controller to use - The controller must be already bootstrapped"
David Garcia79f4f532020-04-07 12:59:34 +020054 echo -e " --nolxd: do not install and configure LXD, allowing unattended installations (assumes LXD is already installed and confifured)"
garciadeblas38d91ee2019-11-07 16:31:23 +010055 echo -e " --nodocker: do not install docker, do not initialize a swarm (assumes docker is already installed and a swarm has been initialized)"
56 echo -e " --nojuju: do not juju, assumes already installed"
57 echo -e " --nodockerbuild:do not build docker images (use existing locally cached images)"
58 echo -e " --nohostports: do not expose docker ports to host (useful for creating multiple instances of osm on the same host)"
59 echo -e " --nohostclient: do not install the osmclient"
60 echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules"
61 echo -e " --source: install OSM from source code using the latest stable tag"
62 echo -e " --develop: (deprecated, use '-b master') install OSM from source code using the master branch"
garciadeblas38d91ee2019-11-07 16:31:23 +010063 echo -e " --pullimages: pull/run osm images from docker.io/opensourcemano"
garciadeblas9dee2a62020-11-14 23:08:37 +000064 echo -e " --k8s_monitor: install the OSM kubernetes monitoring with prometheus and grafana"
65 echo -e " --volume: create a VM volume when installing to OpenStack"
garciadeblas38d91ee2019-11-07 16:31:23 +010066 echo -e " --showopts: print chosen options and exit (only for debugging)"
67 echo -e " -y: do not prompt for confirmation, assumes yes"
68 echo -e " -h / --help: print this help"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020069 echo -e " --charmed: Deploy and operate OSM with Charms on k8s"
70 echo -e " [--bundle <bundle path>]: Specify with which bundle to deploy OSM with charms (--charmed option)"
71 echo -e " [--k8s <kubeconfig path>]: Specify with which kubernetes to deploy OSM with charms (--charmed option)"
garciadeblas9dee2a62020-11-14 23:08:37 +000072 echo -e " [--vca <name>]: Specifies the name of the controller to use - The controller must be already bootstrapped (--charmed option)"
73 echo -e " [--lxd <yaml path>]: Takes a YAML file as a parameter with the LXD Cloud information (--charmed option)"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020074 echo -e " [--lxd-cred <yaml path>]: Takes a YAML file as a parameter with the LXD Credentials information (--charmed option)"
75 echo -e " [--microstack]: Installs microstack as a vim. (--charmed option)"
Dominik Fleischmannc57296f2020-06-09 11:45:08 +020076 echo -e " [--ha]: Installs High Availability bundle. (--charmed option)"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020077 echo -e " [--tag]: Docker image tag"
78
garciadeblas38d91ee2019-11-07 16:31:23 +010079}
80
garciadeblasd8bc5c32018-05-09 17:37:56 +020081add_repo() {
82 REPO_CHECK="^$1"
83 grep "${REPO_CHECK/\[arch=amd64\]/\\[arch=amd64\\]}" /etc/apt/sources.list > /dev/null 2>&1
84 if [ $? -ne 0 ]
85 then
garciadeblasbd925e42018-06-14 14:32:12 +020086 need_packages_lw="software-properties-common apt-transport-https"
87 echo -e "Checking required packages: $need_packages_lw"
88 dpkg -l $need_packages_lw &>/dev/null \
89 || ! echo -e "One or several required packages are not installed. Updating apt cache requires root privileges." \
90 || sudo apt-get -q update \
Mike Marchetti34124182018-10-16 08:22:30 -040091 || ! echo "failed to run apt-get update" \
garciadeblasbd925e42018-06-14 14:32:12 +020092 || exit 1
93 dpkg -l $need_packages_lw &>/dev/null \
94 || ! echo -e "Installing $need_packages_lw requires root privileges." \
95 || sudo apt-get install -y $need_packages_lw \
Mike Marchetti34124182018-10-16 08:22:30 -040096 || ! echo "failed to install $need_packages_lw" \
garciadeblasbd925e42018-06-14 14:32:12 +020097 || exit 1
garciadeblasd8bc5c32018-05-09 17:37:56 +020098 wget -qO - $REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg | sudo apt-key add -
99 sudo DEBIAN_FRONTEND=noninteractive add-apt-repository -y "$1" && sudo DEBIAN_FRONTEND=noninteractive apt-get update
garciadeblas429b9f82018-03-20 02:09:44 +0100100 return 0
garciadeblasd8bc5c32018-05-09 17:37:56 +0200101 fi
102
103 return 1
garciadeblas55490d42016-10-29 14:22:03 +0200104}
105
garciadeblas25e87d22020-01-31 14:27:29 +0100106clean_old_repo() {
madaviae0784f2020-01-22 16:29:19 +0530107dpkg -s 'osm-devops' &> /dev/null
madaviae0784f2020-01-22 16:29:19 +0530108if [ $? -eq 0 ]; then
madaviae0784f2020-01-22 16:29:19 +0530109 # Clean the previous repos that might exist
110 sudo sed -i "/osm-download.etsi.org/d" /etc/apt/sources.list
111fi
112}
113
vijaynag4b57d462020-06-08 14:23:10 +0000114while getopts ":b:r:c:n:k:u:R:l:L:K:p:D:o:O:m:N:H:S:s:w:t:U:P:A:-: hy" o; do
garciadeblas38d91ee2019-11-07 16:31:23 +0100115 case "${o}" in
garciadeblas38d91ee2019-11-07 16:31:23 +0100116 r)
117 REPOSITORY="${OPTARG}"
118 ;;
119 R)
120 RELEASE="${OPTARG}"
121 ;;
122 u)
123 REPOSITORY_BASE="${OPTARG}"
124 ;;
125 t)
garciadeblas25e87d22020-01-31 14:27:29 +0100126 DOCKER_TAG="${OPTARG}"
garciadeblas38d91ee2019-11-07 16:31:23 +0100127 ;;
garciadeblas72399e32019-11-22 10:09:40 +0100128 -)
129 [ "${OPTARG}" == "help" ] && usage && exit 0
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +0100130 ;;
garciadeblas25e87d22020-01-31 14:27:29 +0100131 :)
132 echo "Option -$OPTARG requires an argument" >&2
133 usage && exit 1
134 ;;
135 \?)
136 echo -e "Invalid option: '-$OPTARG'\n" >&2
137 usage && exit 1
138 ;;
139 h)
140 usage && exit 0
141 ;;
garciadeblas38d91ee2019-11-07 16:31:23 +0100142 *)
143 ;;
144 esac
145done
146
garciadeblas25e87d22020-01-31 14:27:29 +0100147clean_old_repo
garciadeblasd8bc5c32018-05-09 17:37:56 +0200148add_repo "deb [arch=amd64] $REPOSITORY_BASE/$RELEASE $REPOSITORY devops"
garciadeblas35f96ae2018-05-23 12:33:36 +0200149sudo DEBIAN_FRONTEND=noninteractive apt-get -q update
150sudo DEBIAN_FRONTEND=noninteractive apt-get install osm-devops
garciadeblasa5e66072019-05-29 12:23:22 +0200151/usr/share/osm-devops/installers/full_install_osm.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D /usr/share/osm-devops -t $DOCKER_TAG "$@"